<template>
  <ObForm
    :form-model="formModel"
    :form-data="formData"
    ok-text="Сохранить"
    cancel-text="Отменить"
    @submit="onSubmit"
  >
    <div class="row">
      <div class="col-xs-12">
        <ob-input
          label="БИК"
          placeholder="Укажите БИК"
          :required="true"
          :is-valid="isBikValid"
          v-model="formData.bik"
          @input="debouncedGetBikInfo($event)"
        />
      </div>
    </div>
    <div v-if="formData.bik && isBikValid === false">
      <div class="row">
        <div class="col-xs-12">
          <span class="error-message">
            Не получается автоматически найти данные банка. Пожалуйста, свяжитесь со службой поддержки платформы {{ platformName }} по телефону <a :href="`tel:${linkphone}`">{{ phone }}</a> или почте <a :href="`mailto:${email}`">{{ email }}</a>
          </span>
        </div>
      </div>
    </div>
    <div v-if="formData.bik && isBikValid">
      <div class="row">
        <div class="col-xs-12">
          <ob-input
            label="Наименование банка"
            placeholder="Наименование банка"
            :disabled="true"
            v-model="formData.bank"
          />
        </div>
      </div>
      <div class="row">
        <div class="col-xs-12">
          <ob-input
            label="Корр. счёт"
            placeholder="Корр. счёт"
            :disabled="true"
            v-model="formData.correspondentAccount"
          />
        </div>
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-input
          label="Номер расчётного счёта"
          placeholder="Состоит из 20 цифр"
          :is-valid="isPaymentAccountValid"
          :required="true"
          v-model="formData.paymentAccount"
          property="paymentAccount"
        />
      </div>
    </div>
  </ObForm>
</template>

<script>
  import api from '@/api'
  import debounce from 'debounce'
  import { required } from 'vuelidate/lib/validators';
  import { uuid } from 'vue-uuid';

  import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin';
  import ObForm from 'common-components/src/obComponents/obForm';
  import ObInput from 'common-components/src/obComponents/obInput'

  const isPaymentAccountValidLength = (value, formData) => {
    return formData?.paymentAccount.length === 20
  };

  const isPaymentAccountExists = (value, formData) => {
    return formData?.existingAccounts.every(account => account !== formData.paymentAccount)
  };

  export default {
    name: "formAdd",
    mixins: [
      FormValidationMixin
    ],
    components: {
      ObForm,
      ObInput
    },
    computed: {
      participantUuid: ({ $route }) => $route.params.uuid,
      formModel () {
        return {
          bik: {
            validator: {
              required
            }
          },
          bank: {
            validator: {
              required
            }
          },
          correspondentAccount: {
            validator: {
              required
            }
          },
          paymentAccount: {
            validator: {
              required,
              isPaymentAccountExists: {
                method: isPaymentAccountExists,
                error: 'Счёт уже добавлен'
              },
              isPaymentAccountValidLength: {
                method: isPaymentAccountValidLength,
                error: 'Должно быть 20 символов'
              }
            }
          },
          existingAccounts: {
            value: []
          }
        }
      },

      isPaymentAccountValid: ({ formData }) => {
        return formData?.paymentAccount?.length === 20 && formData.existingAccounts.every(account => account !== formData.paymentAccount)
      },
      platform () {
        return window.location.host.includes('oboz')  ? 'oboz' : 'gruzi'
      },
      platformName () {
        return this.platforms[this.platform].name
      },
      phone () {
        return this.platforms[this.platform].phone
      },
      linkphone () {
        return this.platforms[this.platform].linkphone
      },
      email () {
        return this.platforms[this.platform].email
      }
    },
    data() {
      return {
        formData: {},
        isBikValid: null,
        platforms: {
          oboz: {
            name: 'ОБОЗ',
            phone: '+7 (495) 646-06-03',
            linkphone: '+74956460603',
            email: 'support@oboz.com'
          },
          gruzi: {
            name: 'Грузи.Ру',
            phone: '+7 (495) 260-17-78',
            linkphone: '+74952601778',
            email: 'support@gruzi.ru'
          }
        }
      }
    },
    methods: {
      async onSubmit () {
        const payload = {
          bik: this.formData.bik,
          bank: this.formData.bank,
          correspondentAccount: this.formData.correspondentAccount,
          paymentAccount: this.formData.paymentAccount,
          uuid: uuid.v4(),
          participantUuid: this.participantUuid
        };

        await api.organisations.addInvoiceModerator(payload);
        this.$emit('close');
        this.$notification({type: 'snackbars', message: `Вы успешно добавили новый расчетный счёт` });
      },

      debouncedGetBikInfo: debounce(async function(data) {
        let correspondentAccount = '',
            bank = '';

        try {
          const response = await api.registration.accreditation.getBikInfo(data);
          this.isBikValid = true;
          correspondentAccount = response.ks;
          bank = (response.name).replace(/&quot;/g, '"');

        } catch(e) {
          this.isBikValid = false;
          correspondentAccount = '';
          bank = '';
        }

        this.formData.correspondentAccount = correspondentAccount;
        this.formData.bank = bank;

      }, 500),

      async getExistingAccounts() {
        const response = await api.organisations.getInvoicesModerator(this.participantUuid);
        this.formData.existingAccounts = response.accounts.map(account => account.paymentAccount);
      }
    }
  }
</script>

<style lang="scss" scoped>
@import '~common-components/src/static/css/variables';

.error-message {
  font-size: 12px;
  line-height: 16px;
  color: $color-error;
  letter-spacing: .4px;

  a {
    color: inherit;
    text-decoration: none;
  }
}
</style>
